#ifndef FISH_H
#define FISH_H

#include "util.h"

class Fish : public Figure
{
  protected:
    std::shared_ptr<Figure> getFigurePointer();
  public:
    Vector direction;
    Vector upside;
    std::shared_ptr<Fish> clone() const;
    Fish();
    void applyTransformations();
    void turnInDirection(const Vector &direction, float weight);
    void turnTowards(const Vector &point, float weight);
    void turnAwayFrom(const Vector &point, float weight);
    void straightenOut();
    void moveForward(float amount);
    void rotate(const Vector& rotationAxis, float angle, const Vector& center);
    void rotate(const Vector& rotationAxis, float angle);
};
#endif
